"""
Elective Conversion At Will Object

Type representation of elective trigger valid at will (so long as instrument is
valid and outstanding).

Copyright © 2022 Open Cap Table Coalition (https://opencaptablecoalition.com) /
Original File: https://github.com/Open-Cap-Table-Coalition/Open-Cap-Format-OCF/t
ree/main/schema/types/conversion_triggers/ElectiveConversionAtWillTrigger.schema
.json

Autogenerated, do not edit.
"""

from pyocf.primitives.types.conversion_rights.conversionright import ConversionRight
from pyocf.primitives.types.conversion_triggers.conversiontrigger import (
    ConversionTrigger,
)
from typing import Literal


class ElectiveConversionAtWillTrigger(ConversionTrigger):
    """Elective Conversion At Will"""

    # Id for this conversion trigger, unique within list of ConversionTriggers in
    # parent convertible issuance's `conversion_triggers` field.
    trigger_id: str
    # Human-friendly nickname to describe the conversion right
    nickname: str | None
    # Long-form description of the trigger
    trigger_description: str | None
    type: Literal["ELECTIVE_AT_WILL"] = "ELECTIVE_AT_WILL"
    # When the conditions of the trigger are met, how does the convertible convert?
    conversion_right: ConversionRight
